image:
  name: ghcr.io/foundry-rs/foundry
  entrypoint: [""]

include: 
  - project: "projecttxa/txa-utils/txa-ci-templates"
    file: "/templates/gpg-validate.yml"
  - project: "projecttxa/txa-utils/txa-ci-templates"
    file: "/templates/docker.yml"

variables:
    IMAGE_TAG: "$CI_REGISTRY_IMAGE/txa-network-contracts:latest"
    VERSIONED_IMAGE_TAG: "$CI_REGISTRY_IMAGE/txa-network-contracts:0.2.6"
    GPG_FILE: "settlements.csv"
    DOCKER_TLS_CERTDIR: "/certs"
    GIT_SUBMODULE_STRATEGY: recursive

.before_script:
  before_script:
    - forge install
    # below is necessary to prevent `fatal: unsafe repository`
    - git config --global --add safe.directory /builds/projecttxa/txa-dsl/txa-network-contracts

stages:
  - validate
  - test
  - test-scripts
  - test-build
  - publish

gpg_validate:
  stage: validate
  extends:
    - .gpg-validate

unit-tests:
  extends: .before_script
  stage: test
  tags: [docker]
  only:
    - merge_requests
  except:
    - develop@projecttxa/txa-dsl/txa-network-contracts
    - master@projecttxa/txa-dsl/txa-network-contracts
  script:
    - forge test -vvv

test-scripts:
  extends: .before_script
  stage: test
  tags: [docker]
  only:
    - merge_requests
  except:
    - develop@projecttxa/txa-dsl/txa-network-contracts
    - master@projecttxa/txa-dsl/txa-network-contracts
  script:
    - anvil &
    - sleep 5
    - PRIVATE_KEY="0xac0974bec39a17e36ba4a6b4d238ff944bacb478cbed5efcae784d7bf4f2ff80" forge script script/DeployBaseChain.s.sol --rpc-url http://127.0.0.1:8545 --broadcast
    - PRIVATE_KEY="0xac0974bec39a17e36ba4a6b4d238ff944bacb478cbed5efcae784d7bf4f2ff80" forge script script/DepositNativeAsset.s.sol --rpc-url http://127.0.0.1:8545 --broadcast
    - PRIVATE_KEY="0xac0974bec39a17e36ba4a6b4d238ff944bacb478cbed5efcae784d7bf4f2ff80" forge script script/RequestSettlementNativeAsset.s.sol --rpc-url http://127.0.0.1:8545 --broadcast

unit-tests-upstream:
  extends: .before_script
  stage: test
  tags: [docker]
  only:
    - develop@projecttxa/txa-dsl/txa-network-contracts
    - master@projecttxa/txa-dsl/txa-network-contracts
  script:
    - forge test -vvv
    - forge script script/DeployBaseChain.s.sol

test-build:
  stage: test-build
  needs: [unit-tests]
  except:
    - develop@projecttxa/txa-dsl/txa-network-contracts
    - master@projecttxa/txa-dsl/txa-network-contracts
  only:
    - merge_requests
  extends:
    - .docker-base
  script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker build -t $IMAGE_TAG .

publish:
  stage: publish
  extends:
    - .docker-build
  script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker build -t $IMAGE_TAG .
    - docker tag $IMAGE_TAG $VERSIONED_IMAGE_TAG
    - docker push $IMAGE_TAG
    - docker push $VERSIONED_IMAGE_TAG
  rules:
    - if: '$CI_COMMIT_BRANCH == "beta-deploy" && $CI_COMMIT_MESSAGE =~ /^Merge branch .+/'
